package convoynet

import (
	"fmt"

	"wartank/pkg/components/sectionnet"
	"wartank/pkg/types"
)

/*
	Автоматически воюет с конвоем в сети
*/

// ConvoyNet -- танкует с конвоем в сети
type ConvoyNet struct {
	*sectionnet.SectionNet
	server types.IServer
	bot    types.IServBot
}

// NewConvoyNet -- возвращает новый *ConvoyNet
func NewConvoyNet(server types.IServer, bot types.IServBot) (*ConvoyNet, error) {
	{ // Предусловия
		if server == nil {
			return nil, fmt.Errorf("NewConvoyNet(): IServer == nil")
		}
		if bot == nil {
			return nil, fmt.Errorf("NewConvoyNet(): IServBot == nil")
		}
	}

	sf := &ConvoyNet{
		server: server,
		bot:    bot,
	}
	return sf, nil
}

func (sf *ConvoyNet) Run() error {
	sf.SectionNet = sectionnet.NewSectionNet(sf.server, sf.bot, sf.bot.Angar().Convoy(), "http://wartank.ru/convoy")
	return nil
}
